// DirectX Boost extra stuff.
// Also spike busting.

addHook("MobjCollide", function(malware, defender)
	if (defender.skin ~= "windows" or not defender.player) then return end
	if malware.z + malware.height < defender.z + defender.momz or malware.z > defender.z + defender.momz + defender.height then return nil end
	local ram = defender.player
	if (ram.powers[pw_super] != 0 or ram.powers[pw_invulnerability] != 0) then
		P_KillMobj(malware, defender, defender, nil, nil)
	elseif ram.cpanel > 0 then
		P_KillMobj(malware, defender, defender, nil, nil)
	elseif ram.speed > 35*FRACUNIT then
		P_KillMobj(malware, defender, defender, nil, nil)
	end
end, MT_SPIKE)

addHook("MobjCollide", function(malware, defender)
	if (defender.skin ~= "windows" or not defender.player) then return end
	if malware.z + malware.height < defender.z + defender.momz or malware.z > defender.z + defender.momz + defender.height then return nil end
	local ram = defender.player
	if (ram.powers[pw_super] != 0 or ram.powers[pw_invulnerability] != 0) then
		P_KillMobj(malware, defender, defender, nil, nil)
	elseif ram.cpanel > 0 then
		P_KillMobj(malware, defender, defender, nil, nil)
	elseif ram.speed > 35*FRACUNIT then
		P_KillMobj(malware, defender, defender, nil, nil)
	end
end, MT_WALLSPIKE)

// Busting through FoFs.
// Thanks for the blessing, SMS Alfredo!
local function bustcheck(fof)
    return fof and fof.valid and fof.flags & (FF_EXISTS|FF_BUSTUP) == (FF_EXISTS|FF_BUSTUP)
end

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid) and player.mo.skin == "windows" then
		local sectorthing = P_PlayerTouchingSectorSpecial(player, 0, 0)
		if sectorthing and sectorthing.valid then
			for fof in sectorthing.ffloors()
				if fof.valid and (abs(fof.topheight - player.mo.z) <= 40*player.mo.scale
				or abs(fof.bottomheight - player.mo.z+player.mo.height) <= 40*player.mo.scale)
				and fof.master and fof.master.valid and fof.master.flags & ML_NOCLIMB
				and (fof.master.special == 153 or fof.master.special == 180
				or (fof.master.special >= 150 and fof.master.special <= 152)
				or (fof.master.special >= 190 and fof.master.special <= 195)
				or fof.master.special == 176 or fof.master.special == 177) then
					if P_IsObjectOnGround(player.mo) then
						player.pflags = $ | (PF_STARTDASH | PF_SPINNING)
						P_InstaThrust(player.mo,0,0)
					end
				end
			end
		end
		// The Guy, The Lua was here too, perhaps?
		if bustcheck(player.mo.floorrover) and player.mo.z == player.mo.floorrover.topheight
			EV_CrumbleChain(player.mo.floorrover)
		end
		if bustcheck(player.mo.ceilingrover) and (player.mo.z + player.mo.height) == player.mo.ceilingrover.bottomheight
			EV_CrumbleChain(player.mo.ceilingrover)
		end
    end
end)