// The funny. Moved out of character-specific
// Lua to apply it to others.

freeslot("SFX_FUNDIE")

sfxinfo[sfx_fundie] = {
        singular = false,
        priority = 25,
		flags = SF_X4AWAYSOUND,
		caption = "funnydeath.mp4"
}

// The Funny Switch.
local funnydeath = CV_RegisterVar({
	name = "funisdeath",
	defaultvalue = 1,
	flags = CV_NETVAR | CV_SHOWMODIF,
	PossibleValue = CV_OnOff
})

addHook("PlayerThink", function(player)
	if funnydeath.value != 1 then return end
	if player.playerstate == PST_DEAD and player.fundeath == 0 then
		player.fundeath = 1
		if P_RandomChance(FRACUNIT/8) == true
			player.mo.flags2 = $ | MF2_DONTDRAW
			S_StopSound(player.mo)
			S_StartSound(player.mo, sfx_fundie)
			local flatulence = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_BOSSEXPLODE)
			flatulence.scale = 3 << FRACBITS
		end
	end
	if S_SoundPlaying(player.mo, sfx_fundie) and player.playerstate == PST_DEAD and player.fundeath == 1 then
		player.mo.momz = -1
	end
	if player.playerstate == PST_REBORN then
		player.winpopup = 15*TICRATE
		player.cpanel = 0
		player.xpcooldown = 60*TICRATE
		player.fundeath = 0
	end
end)