// HUD stuffing.

local function WinHUD(v, player)
	if player.mo and player.mo.valid and player.mo.skin == "windows" then
		if player.winpopup != nil and player.xpcooldown != nil then
			local winready = v.cachePatch("WINREADY")
			local winwarn = v.cachePatch("WINWARN")
			local kgrow = v.cachePatch("KGROW")
			local winnotready = v.cachePatch("WINNOT")
			local directx = v.cachePatch("WINDX")
			local directxbw = v.cachePatch("WINDX1")
			local spiking = v.cachePatch("WINBUST")
			local growth = CV_FindVar("kartgrow")
			local directxtoggle = CV_FindVar("DirectX")
			local kflash = leveltime%2
			local run = (15*TICRATE - player.winpopup) / TICRATE
			local clocking = (60*TICRATE - player.xpcooldown) / TICRATE
			local growthtimer = (player.powers[pw_sneakers] / TICRATE)
			if player.powers[pw_super] != 0 then
				if player.xpcooldown != 60*TICRATE then
					v.draw(17, 141, winnotready, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					v.drawString(37, 145, (clocking), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_GRAYMAP, "thin")
				elseif player.xpcooldown == 60*TICRATE then
					if player.hyper == nil or player.hyper.capable == false then
						v.draw(17, 141, winready, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
						v.drawString(37, 145, ("Ready"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_GREENMAP, "thin")
					elseif player.hyper and player.hyper.capable == true
						v.draw(17, 141, winwarn, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
						v.drawString(37, 145, ("Ready"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_YELLOWMAP, "thin")
					end
				end
			end
			if growth.value == 1 and player.powers[pw_sneakers] != 0 then
				if kflash == 1 then
					v.draw(292, 10, kgrow, V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
				end
				if player.powers[pw_sneakers] >= 3*TICRATE then
					v.drawString(300, 16, growthtimer, V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANSDOUBLE|V_BLUEMAP, "center")
				elseif player.powers[pw_sneakers] < 3*TICRATE then
					if kflash == 1 then v.drawString(300, 16, growthtimer, V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANSDOUBLE|V_REDMAP, "center") end
				end
			end
			if directxtoggle.value == 1 then
				if player.winpopup == 15*TICRATE then
					v.draw(16, 158, directx, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					v.drawString(37, 162, ("Ready"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_YELLOWMAP, "thin")
				elseif player.winpopup < 15*TICRATE then
					v.draw(16, 158, directxbw, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
					v.drawString(37, 162, run, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_GRAYMAP, "thin")
				end
			end
			if player.exiting == 0 then
				if (player.powers[pw_super] != 0 or player.powers[pw_invulnerability] != 0) then
					v.draw(16, 125, spiking, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				elseif player.cpanel > 0 then
					v.draw(16, 125, spiking, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				elseif player.speed > 35*FRACUNIT then
					v.draw(16, 125, spiking, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
				end
			end
		end
	end
end
hud.add(WinHUD, "game")