// Super form ability.
// As well as the Hyper extension, if XMomentum is present.

freeslot("SFX_XPBMB", "SFX_NT5PWR", "SFX_WINRDY")

// Local flash variable. Not Flash, though.
local protecteyes = CV_RegisterVar({
	name = "winflash",
	defaultvalue = 0,
	flags = CV_SHOWMODIF,
	PossibleValue = CV_YesNo
})

sfxinfo[sfx_xpbmb] = {
        singular = false,
        priority = 95,
        flags = SF_X8AWAYSOUND,
		caption = "XPerience Blast"
}

sfxinfo[sfx_winrdy] = {
        singular = false,
        priority = 80,
        flags = SF_X2AWAYSOUND,
		caption = "Blast Ready"
}

sfxinfo[sfx_nt5pwr] = {
        singular = false,
        priority = 95,
        flags = SF_X2AWAYSOUND|SF_X4AWAYSOUND|SF_X8AWAYSOUND,
		caption = "The NT5 Revolution"
}

local function WhenYouStubYourToe()
	for player in players.iterate
		P_DoPlayerPain(player)
		P_SetObjectMomZ(player.mo, 10*FRACUNIT)
		P_InstaThrust(player.mo, player.mo.angle, -20*FRACUNIT)
	end
end

addHook("PlayerThink", function(player)
	if (player.mo and player.mo.valid) and player.mo.skin != "windows" then return
	elseif (player.mo and player.mo.valid) and player.mo.skin == "windows" then
		if player.xpcooldown < 60*TICRATE and gamestate != 4 then
			player.xpcooldown = $ + 1
			if player.xpcooldown == 60*TICRATE - 1 then S_StartSound(player.mo, sfx_winrdy)
			elseif player.xpcooldown > 60*TICRATE then player.xpcooldown = 60*TICRATE end
		end
		if player.powers[pw_shield] == 3 and player.powers[pw_super] != 0 then
			player.xpcooldown = 60*TICRATE - 5
			player.powers[pw_shield] = 0
		elseif player.powers[pw_super] == 0 then player.xpcooldown = 60*TICRATE end
		if player.cmd.buttons & BT_CUSTOM1 then
			if player.xpcooldown == 60*TICRATE then
				if player.powers[pw_super] != 0 then
					if player.hyper == nil or player.hyper.capable == false then
						P_NukeEnemies(player.mo, player.mo, 2048*FRACUNIT)
						if protecteyes.value != 0 then
							P_FlashPal(player, PAL_WHITE, 5)
							P_StartQuake(50*FRACUNIT, 5)
						elseif player.hyperflash != nil then
							if player.hyperflash == 1 then
								P_FlashPal(player, PAL_WHITE, 5)
								P_StartQuake(50*FRACUNIT, 5)
							end
						end
						player.xpcooldown = 55*TICRATE
						S_StartSound(player.mo, sfx_xpbmb)
						if player.rings <= 5 then player.rings = 0 else player.rings = $ - 5 end
					elseif player.hyper.capable == true then
						// The AoE attack is overclocked to instability amounts!
						// You... should probably be careful about using it.
						// Because it's not just enemies that will feel it.
						if protecteyes.value != 0 then
							if player.hyperflash == 1 then
								P_FlashPal(player, PAL_NUKE, TICRATE) // boom.
								P_StartQuake(150*FRACUNIT, 3*TICRATE)
							end
						end
						P_NukeEnemies(player.mo, player.mo, 16384*FRACUNIT)
						player.xpcooldown = 0
						WhenYouStubYourToe()
						S_StartSound(player.mo, sfx_nt5pwr)
						P_PlayRinglossSound(player.mo)
						P_PlayerRingBurst(player, 32)
						if player.rings <= 150 then player.rings = 0 else player.rings = $ - 150 end
						P_SetObjectMomZ(player.mo, 30*FRACUNIT)
						P_InstaThrust(player.mo, player.mo.angle, -60*FRACUNIT)
						P_PlayerRingBurst(player, 32)
					end
				end
			end
		end
	end
end)